
// TestSetDefDlgIDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestSetDefDlgID.h"
#include "TestSetDefDlgIDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestSetDefDlgIDDlg dialog




CTestSetDefDlgIDDlg::CTestSetDefDlgIDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestSetDefDlgIDDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestSetDefDlgIDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LV_AVAILABLE, m_wndLVAvailable);
	DDX_Control(pDX, IDC_LV_SELECTED, m_wndLVSelected);
	DDX_Control(pDX, IDC_BT_ADD, m_wndBtnAdd);
	DDX_Control(pDX, IDC_BT_REMOVE, m_wndBtnRemove);
}

BEGIN_MESSAGE_MAP(CTestSetDefDlgIDDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LV_AVAILABLE, &CTestSetDefDlgIDDlg::OnLvnItemchangedLV)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LV_SELECTED, &CTestSetDefDlgIDDlg::OnLvnItemchangedLV)
	ON_BN_CLICKED(IDC_BT_ADD, &CTestSetDefDlgIDDlg::OnAdd)
	ON_BN_CLICKED(IDC_BT_REMOVE, &CTestSetDefDlgIDDlg::OnRemove)
END_MESSAGE_MAP()


// CTestSetDefDlgIDDlg message handlers

BOOL CTestSetDefDlgIDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Add some columns
	CRect rect;
	m_wndLVSelected.GetClientRect(rect);
	int iWidth = rect.Width()-::GetSystemMetrics(SM_CXHSCROLL);
	m_wndLVAvailable.InsertColumn(0,_T("Name"),LVCFMT_LEFT,iWidth);
	m_wndLVSelected.InsertColumn(0,_T("Name"),LVCFMT_LEFT,iWidth);

	// Insert data
	for (int i=0; i<100; ++i)
	{
		CString strText;
		strText.Format(_T("Entry %02d"),i);
		m_wndLVAvailable.InsertItem(m_wndLVAvailable.GetItemCount(), strText);
	}

	// Help the user to see a focused item
	m_wndLVAvailable.SetItemState(0,LVIS_FOCUSED,LVIS_FOCUSED);

	// Enable controls so that they reflect the state
	EnableCtrls();
	return TRUE;  
}

void CTestSetDefDlgIDDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestSetDefDlgIDDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestSetDefDlgIDDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestSetDefDlgIDDlg::OnLvnItemchangedLV(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	*pResult = 0;

//	if ((pNMLV->uOldState & LVIS_SELECTED)!=(pNMLV->uNewState & LVIS_SELECTED))
		EnableCtrls();
}

void CTestSetDefDlgIDDlg::EnableCtrls()
{
	// Check who has the focus
	CWnd *pwndFocus = GetFocus();
	CListCtrl *pwndLstToCheck = NULL;
	UINT uID;
	if (pwndFocus==&m_wndLVAvailable)
	{
		uID = IDC_BT_ADD;
		pwndLstToCheck = &m_wndLVAvailable;
	}
	else if (pwndFocus==&m_wndLVSelected)
	{
		uID = IDC_BT_REMOVE;
		pwndLstToCheck = &m_wndLVSelected;
	}
	
	// Do we have a list view with focus?
	// By default IDOK is the standard button
	UINT uiDefDlgID = IDOK;
	if (pwndLstToCheck)
	{
		if (pwndLstToCheck->GetFirstSelectedItemPosition())
			uiDefDlgID = uID;
	}

	// Set default ID
	SetDefID(uiDefDlgID);

	// Enable or disable the move buttons depending on selection
	TRACE(m_wndLVAvailable.GetFirstSelectedItemPosition()!=NULL ? "Something selected\n" : "Nothing selected\n");
	m_wndBtnAdd.EnableWindow(m_wndLVAvailable.GetFirstSelectedItemPosition()!=NULL);
	m_wndBtnRemove.EnableWindow(m_wndLVSelected.GetFirstSelectedItemPosition()!=NULL);
}

void CTestSetDefDlgIDDlg::OnAdd()
{
	Move(m_wndLVAvailable,m_wndLVSelected);
}

void CTestSetDefDlgIDDlg::OnRemove()
{
	Move(m_wndLVSelected,m_wndLVAvailable);
}

void CTestSetDefDlgIDDlg::Move(CListCtrl &wndFrom, CListCtrl &wndTo)
{
	int iFocused = wndFrom.GetNextItem(-1,LVNI_FOCUSED);
	int iItem=-1, iLastItem = -1;
	while ((iItem=wndFrom.GetNextItem(iItem,LVNI_SELECTED))!=-1)
	{
		CString strText = wndFrom.GetItemText(iItem,0);

		// Add item to destination
		iLastItem = wndTo.InsertItem(wndTo.GetItemCount(),strText);
		// Select moved items
		if (iLastItem!=-1)
			wndTo.SetItemState(iLastItem,LVIS_FOCUSED,LVIS_FOCUSED);

		// Remove from source
		wndFrom.DeleteItem(iItem);

		// Search from one position back
		--iItem;
	}

	// Set focused item in the from window
	int iMax = wndFrom.GetItemCount();
	if (iMax)
		wndFrom.SetItemState(min(iFocused,iMax-1),LVIS_FOCUSED,LVIS_FOCUSED);

	// Set focus to the last item in the to window
	wndTo.SetItemState(iLastItem,LVIS_FOCUSED,LVIS_FOCUSED);
}
